
%% Tipi di rappresentazione di immagini numeriche in MATLAB

close all;

[imgName, path] = uigetfile('*.jpg;*.bmp;*.png;*.tiff;*.jpeg', 'Pick an image file');
img_rgb = imread([path imgName]);

%Truecolor
figure;
imshow(img_rgb);
title('Immagine Truecolor');

%... per leggere i piani di colore
img_rgb_red_plane = img_rgb(:,:,1);
img_rgb_green_plane = img_rgb(:,:,2);
img_rgb_blue_plane = img_rgb(:,:,3);

%... per visualizzare i piani di colore nelle 3 componenti:
subplot(1,3,1); imshow(img_rgb_red_plane); title('Componente RED');
subplot(1,3,2); imshow(img_rgb_green_plane); title('Componente GREEN');
subplot(1,3,3); imshow(img_rgb_blue_plane); title('Componente BLUE');
pause;

%Indexed (a partire da truecolor, mappa della indexed a 16 colori, no applicazione di algoritmo di dithering)
[img_rgb_ind map_rgb_ind] = rgb2ind(img_rgb, 16, 'nodither');
figure; imshow(img_rgb_ind, map_rgb_ind); colorbar; title('Immagine Indexed con mappa a 16 colori (falsi contorni+colori piatti)');
pause;


%% Conversioni tra tipi di immagini
close all;
 
%rgb --> gray
gray_image = rgb2gray(img_rgb); 
imshow(gray_image);
subplot(1,2,1); imshow(gray_image); title('Img a L.d.G.');

%gray --> binaria
bw_image = im2bw(gray_image); 
subplot(1,2,2); imshow(bw_image); title('Img Binaria');


img_ycbcr  = rgb2ycbcr(img_rgb);
subplot(1,3,1); imshow(img_ycbcr(:,:,1), []); title('Piano Y');
subplot(1,3,2); imshow(img_ycbcr(:,:,2), []); title('Piano Cb');
subplot(1,3,3); imshow(img_ycbcr(:,:,3), []); title('Piano Cr');

img_rgb_Ric = ycbcr2rgb(img_ycbcr);

%HSV
img_hsv = rgb2hsv(img_rgb);
subplot(1,3,1); imshow(img_hsv(:,:,1)); title('Piano H');
subplot(1,3,2); imshow(img_hsv(:,:,2)); title('Piano S');
subplot(1,3,3); imshow(img_hsv(:,:,3)); title('Piano V');
 
