function [B] = background(img_gray, thresh, metric)
%function [B] = background(img_gray) 
%This function revceives as input a gray scale image,the binarization
%threshold (opt), the metric to adopt(4 or 8) (opt
%Compute the background and plot the original image, the binary img and the Background
%Output: the Background image


if nargin<3
    metric = 4; %default value for the threshold
end
if nargin<2
    thresh = 0.5; %default value for the threshold
end

subplot(1,4,1);
imshow(img_gray);
title('Gray scale original image');

%Image binarization
dim= size(img_gray);
BW = im2bw(img_gray, thresh);
subplot(1,4,2);
imshow(BW);
title('Binary image');


%% Background definition

BW_complement = not(BW);

subplot(1,4,3);
imshow(BW_complement);
title('Foreground complement');

%Frame image
frame = false(dim);
frame(1:end,1)=1;
frame(1:end,end)=1;
frame(1,1:end,1)=1;
frame(end, 1:end)=1;

%etichetto le regioni dell'img complemento
[L_comp, num_comp] = bwlabel(BW_complement, metric);

%creo l'img che avr a 1 i pixel corrispondenti ai buchi
B = false(dim);
for i = 1:num_comp    
    reg = ismember(L_comp,i);
    if sum(sum(and(reg, frame)))~= 0
        B = or(B, reg);
    end        
end

subplot(1,4,4);
imshow(B);
title('Image background');

end