function [L] = regions_alg(img_gray, thresh)
%function [L] = regions(img_gray, thresh) this function revceives as input
%a gray scale image and a threshold (opt)
%close the holes, compute the connected regions, plot the regions with a colormap, the
%biggest one and the most eccentric. Output: the labelled connected regions

if nargin<2
    thresh = 0.5;
end

%visualizzo l'img a l.d.g.
subplot(2,2,1);
imshow(img_gray);
title(' img originale a l.d.g.');

%binarizzo l'img con la soglia data o di default
dim= size(img_gray);
BW = im2bw(img_gray, thresh);

%% CERCO e CHIUDO i buchi

BW_complement = not(BW);

%Costruisco l'img frame
frame = false(dim);
frame(1:end,1)=1;
frame(1:end,end)=1;
frame(1,1:end,1)=1;
frame(end, 1:end)=1;

%etichetto le regioni dell'img complemento
[L_comp, num_comp] = bwlabel(BW_complement);

%creo l'img che avr a 1 i pixel corrispondenti ai buchi
% holes = logical(zeros(dim(1), dim(2)));
holes = false(dim);
for i = 1:num_comp    
    reg = L_comp == i;
    if sum(sum(and(reg, frame)))== 0
        holes = or(holes, reg);
    end        
end

%l'img da elaborare sar l'unione delle regioni originariamente poste a 1
%pi i bucchi trovati
BW = or(BW, holes); 

%% SULL'IMG BINARIA DEFINITIVA CALCOLO LE PROPRIET RICHIESTE 
%Individuo le regioni connesse nell'img binaria definitiva
[L, num] = bwlabel(BW);
img_rgb = label2rgb(L);
subplot(2,2,2);
imshow(img_rgb);

%calcolo le propriet richieste
attr = regionprops(L, 'Area', 'Eccentricity');
allArea = [attr.Area];
 
maxArea = max(allArea);
idx_max_reg = find(allArea == maxArea); 
max_Reg = L == idx_max_reg ;
subplot(2,2,3);
imshow(max_Reg, []);
title('Regione con Area max');

allEcc = [attr.Eccentricity];
 
maxEcc = max(allEcc);
idx_max_Ecc = find(allEcc == maxEcc);
max_Ecc = L == idx_max_Ecc;
subplot(2,2,4);
imshow(max_Ecc, []);
title('Regione con Eccentricit max');


disp(['Numero di regioni connesse: ', int2str(num)]);
disp(['Massima area: ', int2str(maxArea)]);
disp(['Massima eccentricit: ', int2str(maxEcc)]);

end